#!/bin/bash

######## Please note that BASH is not my language of choice.  I would appreciate more OBVIOUS code suggestions.
######## Find me on QRZ, Linkedin, Facebook or the Googles.  Tadd Torborg  KA2DEW



################ Check to see if this version of Raspberry PI is supported.
################ We like versions 000e and 000f as found in the /proc/cpuinfo file.
cd ~

temp_parsing_file="tempFileForParsing.txt"

rm -f $temp_parsing_file;
cat /proc/cpuinfo | grep Revision > $temp_parsing_file
chmod 644 $temp_parsing_file;
_counta=$( cat $temp_parsing_file );
_countb=${_counta:11}

_value0="000d"     #### Red B+ Chinese
_value1="000e"
_value2="000f"
_value3="0010"
_value4="a21041"   ### Raspberry PI 2 B
_value5="a01041"   ### also Raspberry PI 2 B ??  v1.1
_value6="0013"     ### Raspberry PI B + v2
_value7="900092"   #### Raspberry PI Zero
_value8="a02082"   #### Raspberry PI 3 B
_value9="a22082"   #### Bob's Raspberry PI 3 B

_version_ok=0
if [ $_value0 == $_countb ]; then
    _version_ok=1
   fi
if [ $_value1 == $_countb ]; then
    _version_ok=1
   fi
if [ $_value2 == $_countb ]; then
    _version_ok=1
	fi
if [ $_value3 == $_countb ]; then
    _version_ok=1
	fi
if [ $_value4 == $_countb ]; then
    _version_ok=1
	fi
if [ $_value5 == $_countb ]; then
    _version_ok=1
	fi
if [ $_value6 == $_countb ]; then
    _version_ok=1
	fi
if [ $_value8 == $_countb ]; then
    _version_ok=1
	fi
if [ $_value9 == $_countb ]; then
    _version_ok=1
	fi
_good_result=1
if [ $_version_ok -ne $_good_result ]; then
    echo "PROC CPUINFO:"
    cat /proc/cpuinfo
    sleep 1
    echo
    echo "you have an unexpected version of Raspberry PI"
    echo "TARPN is not supported on this version, so far."
    rm -f $temp_parsing_file;
    exit 0
fi
rm -f $temp_parsing_file;


### Establish a source URL for acquiring updated materials
if [ -f /usr/local/sbin/source_url.txt ];
then
    echo -n;
else
   echo "ERROR0: source URL file not found."
   echo "ERROR0: assuming http://tarpn.net/oct2015"

   echo "ERROR0:"
   echo "ERROR0: Aborting"
   exit 1
fi
_source_url=$( cat /usr/local/sbin/source_url.txt );


######## Check to see if the user has the shutdown service installed.  If not, install it.  If so, just upgraded it.
if [ -f /etc/systemd/system/pi_shutdown.service ];
then
	######## UPDATE pi_shutdown_background.sh
	rm -f pi_shutdown_background.sh*
	wget -o /dev/null $_source_url/pi_shutdown_background.sh
	if [ -f pi_shutdown_background.sh ];
	then
		echo "##### received PI_SHUTDOWN_BACKGROUND script"
		echo "##### Shutting down service"
		sudo systemctl stop pi_shutdown.service
		sleep 5

		echo "##### moving new background shell script file into place"
		chmod +x pi_shutdown_background.sh
		sudo mv pi_shutdown_background.sh /usr/local/sbin/pi_shutdown_background.sh
		echo "##### PI_SHUTDOWN_BACKGROUND script has been updated."
		echo ##### reload service
		sudo systemctl daemon-reload
		sudo systemctl enable pi_shutdown.service
		sudo systemctl start pi_shutdown.service
		echo "##### PI_SHUTDOWN_BACKGROUND script has been updated and the"
		echo "##### OS has been told to resume calling it."
		echo -e "\n\n\n\n"
	else
		echo "##### ERROR4   Did not receive PI_SHUTDOWN_BACKGROUND.  Leaving current copy alone"
	fi

###### Install shutdown service
else
	echo "######"
	echo "######"
	echo "######"
	echo "######   PI SHUTDOWN SERVICE -- not found.  "
	echo "######  Adding service for raspberry pi automatic shutdown and UP notification"
	echo "######"
	sleep 1
	echo "########"

	cd ~

	if [ -f /etc/systemd/system/pi_shutdown.service ];
	then
	   echo "ERROR!  PI SHUTDOWN SERVICE file already existed in /etc/system.d/system."
	   echo "        If you got this message during a clean install, then"
	   echo "        please send a missive about this to tarpn@groups.io"
	   echo "ERROR: Aborting"
	   exit 1;
	fi

	if [ -f ~/pi_shutdown.service ];
	then
	   echo "ERROR!"
	   echo "ERROR!  Premature existence of pi_shutdown.service file in home directory"
	   echo "        If you got this message during a clean install, then"
	   echo "        please send a missive about this to tarpn@groups.io"
	   echo "ERROR: Aborting"
	   exit 1;
	fi


	wget -o /dev/null $_source_url/pi_shutdown.service
	##### now pi_shutdown.service should exist in the home directory
	if [ -f ~/pi_shutdown.service ];
	then
	   echo " "
	else
	   echo "ERROR!  Failed to obtain pi_shutdown.service from the web page."
	   echo "        If you got this message during a clean install, then"
	   echo "        please send a missive about this to tarpn@groups.io"
	   echo "   Note: Outputting debug information to be relayed to debugger."
	   ls -lrat
	   pwd
	   echo "url"
	   echo $_source_url
	   echo "ERROR: Aborting"
	   exit 1
	fi

	sudo mv ~/pi_shutdown.service /etc/systemd/system/pi_shutdown.service
	if [ -f /etc/systemd/system/pi_shutdown.service ];
	then
	### Download files related to automatic operation
	   wget -o /dev/null $_source_url/pi_shutdown_background.sh
	   chmod +x pi_shutdown_background.sh
	   sudo mv pi_shutdown_background.sh /usr/local/sbin

	### Start Shutdown service from the OS
	   echo "##### PI SHUTDOWN SERVICE file installed"
	   sudo systemctl daemon-reload
	   sudo systemctl enable pi_shutdown.service
	   sudo systemctl start pi_shutdown.service
	   echo "##### starting PI SHUTDOWN service  pause 10 seconds"
	   sleep 10
	   sudo systemctl status pi_shutdown.service
	   echo "###########################################################"
	   sleep 1
	else
	   echo "ERROR!  PI SHUTDOWN SERVICE file failed to copy to /etc/system.d/system."
	   echo "        If you got this message during a clean install, then"
	   echo "        please send a missive about this."
	   echo "ERROR: Aborting"
	   exit 1;
	fi
fi

